/*
    webmail -- simple pop3/smtp web e-mail cgi
    Copyright (C) 2000-2003 Dan Cahill

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "main.h"

void printmenuscript(void);

void printmenuscript()
{
	printf("<SCRIPT LANGUAGE='JavaScript'>\r\n");
	printf("<!--\r\n");
	printf("if (document.images) {\r\n");
	printf("image1on = new Image();\r\n");
	printf("image1on.src = '%smenuinbox1.png';\r\n", config.base_image_url);
	printf("image2on = new Image();\r\n");
	printf("image2on.src = '%smenucompose1.png';\r\n", config.base_image_url);
	printf("image3on = new Image();\r\n");
	printf("image3on.src = '%smenulogout1.png';\r\n", config.base_image_url);
	printf("image1off = new Image();\r\n");
	printf("image1off.src = '%smenuinbox0.png';\r\n", config.base_image_url);
	printf("image2off = new Image();\r\n");
	printf("image2off.src = '%smenucompose0.png';\r\n", config.base_image_url);
	printf("image3off = new Image();\r\n");
	printf("image3off.src = '%smenulogout0.png';\r\n", config.base_image_url);
	printf("}\r\n");
	printf("function changeImages() {\r\n");
	printf("	if (document.images) {\r\n");
	printf("		for (var i=0; i<changeImages.arguments.length; i+=2) {\r\n");
	printf("			document[changeImages.arguments[i]].src = eval(changeImages.arguments[i+1] + '.src');\r\n");
	printf("		}\r\n	}\r\n}\r\n");
	printf("// -->\r\n");
	printf("</SCRIPT>\r\n");
}

void printheader()
{
	static short int sent=0;

	if (sent) return;
	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n");
	printf("<HTML>\r\n<HEAD>\r\n<TITLE>%s</TITLE>\r\n", NWM_SERVERNAME);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	if (strlen(config.stylesheet)) {
		printf("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"%s\">\r\n", config.stylesheet);
	} else {
		printf("<STYLE>\r\n");
		printf("A        { color:%s; text-decoration:none }\r\n", config.colour_links);
		printf("A:HOVER  { text-decoration:underline }\r\n");
		printf(".JUSTIFY { text-align:justify }\r\n");
		printf(".TBAR    { color:#505050; font-size:8pt; font-family:Geneva,Arial,Verdana,Sans-Serif; text-decoration:none; }\r\n");
		printf("</STYLE>\r\n");
	}
	printf("</HEAD>\r\n");
	printf("<BODY BGCOLOR=\"%s\" COLOR=\"#000000\" LINK=\"%s\" ALINK=\"%s\" VLINK=\"%s\" TOPMARGIN=0 LEFTMARGIN=0 BOTTOMMARGIN=0 RIGHTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>\r\n", config.colour_bodybg, config.colour_links, config.colour_links, config.colour_links);
	if (config.use_frames!='y') {
		printmenuscript();
		printf("<TABLE BORDER=0 CELLPADDING=3 CELLSPACING=0 HEIGHT=\"100%%\" WIDTH=\"100%%\">\r\n");
		printf("<TR><TD ALIGN=left BGCOLOR=\"%s\" COLSPAN=2>", config.colour_trim);
		printf("<IMG SRC=%sheader.png BORDER=0></TD></TR>\r\n", config.base_image_url);
		printf("<TR><TD ALIGN=center ROWSPAN=1 VALIGN=top BGCOLOR=\"%s\" HEIGH=100%% WIDTH=85>", config.colour_trim);
		printf("<CENTER>\n");
		printf("<A HREF=%s/maillist STYLE='color: FFFFFF; text-decoration: none; font-size=10pt' ONMOUSEOVER=\"changeImages('image1', 'image1on')\" ONMOUSEOUT=\"changeImages('image1', 'image1off')\">\n", request.ScriptName);
		printf("<B>%s</B><BR><IMG NAME=image1 SRC=%smenuinbox0.png BORDER=0></A><BR>\n", NWM_TOP_INBOX, config.base_image_url);
		printf("<A HREF=%s/mailwrite STYLE='color: FFFFFF; text-decoration: none; font-size=10pt' ONMOUSEOVER=\"changeImages('image2', 'image2on')\" ONMOUSEOUT=\"changeImages('image2', 'image2off')\">\n", request.ScriptName);
		printf("<B>%s</B><BR><IMG NAME=image2 SRC=%smenucompose0.png BORDER=0></A><BR>\n", NWM_TOP_COMPOSE, config.base_image_url);
		printf("<A HREF=%s/mailquit STYLE='color: FFFFFF; text-decoration: none; font-size=10pt' ONMOUSEOVER=\"changeImages('image3', 'image3on')\" ONMOUSEOUT=\"changeImages('image3', 'image3off')\">\n", request.ScriptName);
		printf("<B>%s</B><BR><IMG NAME=image3 SRC=%smenulogout0.png BORDER=0></A><BR>\n", NWM_TOP_LOGOUT, config.base_image_url);
		printf("</CENTER>\n");
		printf("</TD><TD VALIGN=top BGCOLOR=\"%s\" HEIGHT=\"100%%\" WIDTH=\"100%%\">\r\n", config.colour_bodybg);
	}
	sent=1;
	return;
}

void printfooter()
{
	static short int sent=0;

	if (sent) return;
	if (config.use_frames!='y') {
//		printf("</TD></TR>\n");
//		printf("<TR><TD>\n");
//		printf("<CENTER><EM><B><FONT SIZE=2 COLOR=\"#909090\">");
//		printf("%s", NWM_COPYRIGHT);
//		printf("</FONT></B></EM>\n</CENTER>\n");
		printf("</TD></TR></TABLE>\n");
	}
	printf("</BODY>\r\n");
	printf("</HTML>\r\n");
	sent=1;
	return;
}

void printlogin()
{
	if (strlen(wmpop3server)<1) strncpy(wmpop3server, config.pop3_host, sizeof(wmpop3server)-1);
	if (strlen(wmsmtpserver)<1) strncpy(wmsmtpserver, config.smtp_host, sizeof(wmsmtpserver)-1);
	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n");
	printf("<HTML>\n<HEAD><TITLE>%s</TITLE>\n", LOGIN_TITLE);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	printf("<META HTTP-EQUIV=\"Description\" CONTENT=\"%s - Copyright (c) 2000-2003 Dan Cahill - http://www.nulllogic.com/webmail/\">\r\n", NWM_SERVERNAME);
	if (strlen(config.stylesheet)) {
		printf("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"%s\">", config.stylesheet);
	} else {
		printf("<STYLE>\r\n");
		printf("A        { color:%s; text-decoration:none }\r\n", config.colour_links);
		printf("A:HOVER  { text-decoration:underline }\r\n");
		printf(".JUSTIFY { text-align:justify }\r\n");
		printf(".TBAR    { color:#505050; font-size:8pt; font-family:Geneva,Arial,Verdana,Sans-Serif; text-decoration:none; }\r\n");
		printf("</STYLE>\r\n");
	}
	printf("</HEAD>\n");
	printf("<BODY BGCOLOR=\"%s\" COLOR=\"#000000\" LINK=\"%s\" ALINK=\"%s\" VLINK=\"%s\" TOPMARGIN=20 LEFTMARGIN=0 MARGINHEIGHT=0 MARGINWIDTH=0>\r\n", config.colour_bodybg, config.colour_links, config.colour_links, config.colour_links);
	printf("<CENTER><BR>\n");
	printf("<TABLE WIDTH=640 CELLPADDING=5 CELLSPACING=0 BORDER=0>\n");
	printf("<TR><TH ALIGN=LEFT BGCOLOR=\"%s\" COLSPAN=2><IMG SRC=\"%sheader.png\" ALT=\"\"></TH></TR>\n", config.colour_trim, config.base_image_url);
	printf("<TR VALIGN=top><TD BGCOLOR=\"#CCCCCC\">\n");
	printf("<TABLE CELLPADDING=8><TR><TD>\n");
	printf("<FORM METHOD=POST ACTION=\"%s/\" NAME=wmlogin>\n", request.ScriptName);
	printf("<B>%s</B><BR>\n", LOGIN_USERNAME);
	printf("<INPUT NAME=WMUSERNAME TYPE=TEXT SIZE=20 VALUE=\"%s\"><BR>\n", wmusername);
	printf("<B>%s</B><BR>\n", LOGIN_PASSWORD);
	printf("<INPUT NAME=WMPASSWORD TYPE=PASSWORD SIZE=20><BR>\n");
	if (config.support_imap!='y') {
		printf("<INPUT NAME=WMSERVERTYPE TYPE=HIDDEN VALUE=\"POP3\">\n");
	}
	if (config.support_pop3!='y') {
		printf("<INPUT NAME=WMSERVERTYPE TYPE=HIDDEN VALUE=\"IMAP\">\n");
	}
	if ((config.support_imap=='y')&&(config.support_pop3=='y')) {
		printf("<B>Server Type</B><BR>\n");
		printf("<SELECT NAME=WMSERVERTYPE>\n");
		printf("<OPTION%s>IMAP\n", strcmp(wmservertype, "IMAP")==0?" SELECTED":"");
		printf("<OPTION%s>POP3\n", strcmp(wmservertype, "POP3")==0?" SELECTED":"");
		printf("</SELECT><BR>\n");
	}
	if (config.allow_userhosts=='y') {
		printf("<B>%s</B><BR>\n", LOGIN_POP3HOST);
		printf("<INPUT NAME=WMPOP3SERVER TYPE=TEXT SIZE=20 VALUE=\"%s\"><BR>\n", wmpop3server);
		printf("<B>%s</B><BR>\n", LOGIN_SMTPHOST);
		printf("<INPUT NAME=WMSMTPSERVER TYPE=TEXT SIZE=20 VALUE=\"%s\"><BR>\n", wmsmtpserver);
	}
	printf("<BR><CENTER>\n<INPUT TYPE=SUBMIT VALUE=Login>\n</CENTER>\n");
	printf("</FORM>\n");
	printf("</TD></TR></TABLE>\n");
	printf("</TD><TD WIDTH=\"100%%\">\n");
	printf("<TABLE CELLPADDING=8><TR><TD>\n");
	printf("<P>%s</P>\n", LOGIN_MESSAGE);
	printf("</TD></TR></TABLE>\n");
	printf("</TD></TR></TABLE>\n");
	if (strlen(wmusername)<1) {
		printf("<SCRIPT LANGUAGE=JavaScript TYPE=\"text/javascript\">\n<!--\ndocument.wmlogin.WMUSERNAME.focus();\n// -->\n</SCRIPT>\n");
	} else {
		printf("<SCRIPT LANGUAGE=JavaScript TYPE=\"text/javascript\">\n<!--\ndocument.wmlogin.WMPASSWORD.focus();\n// -->\n</SCRIPT>\n");
	}
	printf("<EM><B><FONT SIZE=2 COLOR=\"#909090\">");
	printf("%s", NWM_COPYRIGHT);
	printf("</FONT></B></EM>\n</CENTER>\n");
	printf("</BODY>\n</HTML>\n");
	return;
}

void printlogout()
{
	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n");
	printf("<HTML>\n<HEAD><TITLE>%s</TITLE>\n", LOGOUT_TITLE);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	if (strlen(config.stylesheet)) {
		printf("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"%s\">", config.stylesheet);
	} else {
		printf("<STYLE>\r\n");
		printf("A        { color:%s; text-decoration:none }\r\n", config.colour_links);
		printf("A:HOVER  { text-decoration:underline }\r\n");
		printf(".JUSTIFY { text-align:justify }\r\n");
		printf(".TBAR    { color:#505050; font-size:8pt; font-family:Geneva,Arial,Verdana,Sans-Serif; text-decoration:none; }\r\n");
		printf("</STYLE>\r\n");
	}
	printf("</HEAD>\n");
	printf("<BODY BGCOLOR=\"#F0F0F0\" COLOR=\"#000000\" LINK=\"%s\" ALINK=\"%s\" VLINK=\"%s\">\n", config.colour_links, config.colour_links, config.colour_links);
	printf("<CENTER>\n<BR><BR>\n");
	printf("<TABLE BORDER=0 CELLPADDING=2 CELLSPACING=0>\n");
	printf("<TR BGCOLOR=%s><TH><FONT COLOR=%s>%s</FONT></TH></TR>\n", config.colour_trim, config.colour_trimtext, LOGOUT_TITLE);
	printf("<TR BGCOLOR=%s><TD>\n", config.colour_editform);
	printf("%s", LOGOUT_MESSAGE);
	printf("</TD></TR>\n");
	printf("</TABLE>\n");
	printf("<SCRIPT LANGUAGE=JavaScript>\r\n<!--\r\nlocation.replace('%s/');\r\n// -->\r\n</SCRIPT>\r\n", request.ScriptName);
	printf("<META HTTP-EQUIV=\"Refresh\" CONTENT=\"1; URL='%s/'\">\r\n", request.ScriptName);
	printf("</BODY>\n</HTML>\n");
}

void printframeset()
{
	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Frameset//EN\">\r\n");
	printf("<HTML><HEAD><TITLE>%s</TITLE>\r\n", NWM_SERVERNAME);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	printf("</HEAD>\r\n");
	printf("<FRAMESET ROWS='45,*' BORDER=1 FRAMESPACING=0>\r\n");
	printf("<FRAME SRC=%s/topframe NAME=top SCROLLING=NO NORESIZE>\r\n", request.ScriptName);
	printf("<FRAMESET COLS='85,*' BORDER=1 FRAMESPACING=0>\r\n");
	printf("<FRAME SRC=%s/leftframe NAME=left SCROLLING=NO NORESIZE>\r\n", request.ScriptName);
	printf("<FRAME SRC=%s/maillist NAME=main NORESIZE>\r\n", request.ScriptName);
	printf("</FRAMESET>\n</FRAMESET>\r\n");
	printf("<NOFRAMES>\r\n%s\r\n</NOFRAMES>\r\n", ERR_NOFRAMES);
	printf("</HTML>\r\n");
}

void printtopframe()
{
	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n");
	printf("<HTML><HEAD><TITLE>%s</TITLE>\r\n", NWM_SERVERNAME);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	if (strlen(config.stylesheet)) {
		printf("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"%s\">\r\n", config.stylesheet);
	} else {
		printf("<STYLE>\r\n");
		printf("A        { color:%s; text-decoration:none }\r\n", config.colour_links);
		printf("A:HOVER  { text-decoration:underline }\r\n");
		printf(".JUSTIFY { text-align:justify }\r\n");
		printf(".TBAR    { color:#505050; font-size:8pt; font-family:Geneva,Arial,Verdana,Sans-Serif; text-decoration:none; }\r\n");
		printf("</STYLE>\r\n");
	}
	printf("</HEAD>\r\n");
	printf("<BODY BGCOLOR=%s LEFTMARGIN=5 TOPMARGIN=5 MARGINHEIGHT=0 MARGINWIDTH=0>\r\n", config.colour_trim);
	printf("<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 WIDTH=100%%><TR><TD ALIGN=LEFT><IMG SRC=%sheader.png BORDER=0></TD></TR></TABLE>\r\n", config.base_image_url);
	printf("</BODY>\n</HTML>\r\n");
}

void printleftframe()
{
	send_header(0, "1", "text/html", -1, -1);
	printf("<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\">\r\n");
	printf("<HTML><HEAD><TITLE>%s</TITLE>\r\n", NWM_SERVERNAME);
	printf("<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; CHARSET=%s\">\r\n", HTML_CHARSET);
	if (strlen(config.stylesheet)) {
		printf("<LINK REL=\"stylesheet\" TYPE=\"text/css\" HREF=\"%s\">\r\n", config.stylesheet);
	} else {
		printf("<STYLE>\r\n");
		printf("A        { color:%s; text-decoration:none }\r\n", config.colour_links);
		printf("A:HOVER  { text-decoration:underline }\r\n");
		printf(".JUSTIFY { text-align:justify }\r\n");
		printf(".TBAR    { color:#505050; font-size:8pt; font-family:Geneva,Arial,Verdana,Sans-Serif; text-decoration:none; }\r\n");
		printf("</STYLE>\r\n");
	}
	printmenuscript();
	printf("</HEAD>\r\n");
	printf("<BODY BGCOLOR=%s COLOR=#000000 LINK=#FFFFFF ALINK=#FFFFFF VLINK=#FFFFFF LEFTMARGIN=0 TOPMARGIN=5 MARGINHEIGHT=0 MARGINWIDTH=0>\n", config.colour_trim);
	printf("<CENTER>\n");
	printf("<A HREF=%s/maillist STYLE='color: FFFFFF; text-decoration: none; font-size=10pt' TARGET=main ONMOUSEOVER=\"changeImages('image1', 'image1on')\" ONMOUSEOUT=\"changeImages('image1', 'image1off')\">\n", request.ScriptName);
	printf("<B>%s</B><BR><IMG NAME=image1 SRC=%smenuinbox0.png BORDER=0></A><BR>\n", NWM_TOP_INBOX, config.base_image_url);
	printf("<A HREF=%s/mailwrite STYLE='color: FFFFFF; text-decoration: none; font-size=10pt' TARGET=main ONMOUSEOVER=\"changeImages('image2', 'image2on')\" ONMOUSEOUT=\"changeImages('image2', 'image2off')\">\n", request.ScriptName);
	printf("<B>%s</B><BR><IMG NAME=image2 SRC=%smenucompose0.png BORDER=0></A><BR>\n", NWM_TOP_COMPOSE, config.base_image_url);
	printf("<A HREF=%s/mailquit STYLE='color: FFFFFF; text-decoration: none; font-size=10pt' TARGET=_top ONMOUSEOVER=\"changeImages('image3', 'image3on')\" ONMOUSEOUT=\"changeImages('image3', 'image3off')\">\n", request.ScriptName);
	printf("<B>%s</B><BR><IMG NAME=image3 SRC=%smenulogout0.png BORDER=0></A><BR>\n", NWM_TOP_LOGOUT, config.base_image_url);
	printf("</CENTER>\n</BODY>\n</HTML>\n");
}
